#include	<stdio.h>
#include	<Xm/Form.h>
#include	<Xm/Label.h>
#include	<Xm/MessageB.h>
#include	<Xm/RowColumn.h>
#include	<Xm/PushB.h>
#include	<Xm/Text.h>

extern	Arg	ShellArgs[];
extern	int	NShellArg;

typedef	struct {
	Widget	font_menu, style_menu, size_menu;
	Widget	x_text, y_text, alignment_menu;
	char	*text_value;
	XFontStruct	*font_struct;
} TextData;

static	char *font_names[] =
 { "courier", "helvetica", "lucida", "new century", "times", NULL },
*style_names[] = { "normal", "bold", "italic", "italic bold", NULL },
*size_names[] = { "14", "17", "20", "25", "34", NULL };

static void load_font(text,tdata)
Widget	text;
TextData	*tdata;
{
	Widget	selected;
	int	font, style, size;
	char	*fname, *weight, slant;
	char	font_name[128];
	XtVaGetValues(tdata->font_menu,XmNmenuHistory,&selected,NULL);
	XtVaGetValues(selected,XmNuserData,&font,NULL);
	fname = (font == 3)? "new century schoolbook" : font_names[font];
	XtVaGetValues(tdata->style_menu,XmNmenuHistory,&selected,NULL);
	XtVaGetValues(selected,XmNuserData,&style,NULL);
	weight = (style == 0 || style == 2)? "medium" : "bold";
	slant = (style == 0 || style == 1)? 'r' :
		((font > 1)? 'i' : 'o');
	XtVaGetValues(tdata->size_menu,XmNmenuHistory,&selected,NULL);
	XtVaGetValues(selected,XmNuserData,&size,NULL);
	sprintf(font_name,"-*-%s-%s-%c-*-%s-*-100-*-iso8859-1",
		fname,weight,slant,size_names[size]);
	if (!(tdata->font_struct = XLoadQueryFont(XtDisplay(text),font_name)))
		perror(font_name);
}
get_text(text,str,font,x,y,align)
Widget	text;
char	**str;
XFontStruct	**font;
int	*x, *y, *align;
{
	TextData	*tdata;
	char	*str_val;
	Widget	sel;
	XtVaGetValues(text,XmNuserData,&tdata,NULL);
	if (!tdata) {
		fprintf(stderr,"get_text_font: illegal widget %x.\n",text);
		return 0;
	}
	if (!tdata->font_struct) load_font(text,tdata);
	if (!tdata->text_value)
		XtVaGetValues(text,XmNvalue,&(tdata->text_value),NULL);
	*str = tdata->text_value;
	*font = tdata->font_struct;
	XtVaGetValues(tdata->x_text,XmNvalue,&str_val,NULL);
	*x = atoi(str_val); XtFree(str_val);
	XtVaGetValues(tdata->y_text,XmNvalue,&str_val,NULL);
	*y = atoi(str_val); XtFree(str_val);
	XtVaGetValues(tdata->alignment_menu,XmNmenuHistory,&sel,NULL);
	XtVaGetValues(sel,XmNuserData,align,NULL);
	return 0;
}
static void FontCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	TextData *tdata = (TextData *)cl;
	if (tdata->font_struct) XFreeFont(XtDisplay(w),tdata->font_struct);
	tdata->font_struct = NULL;
}
static void TextCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	TextData	*tdata = (TextData *)cl;
	if (tdata->text_value) XtFree(tdata->text_value);
	tdata->text_value = NULL;
}
static Widget make_option_menu(names,name,parent,left,tdata)
char	**names, *name;
Widget	parent, left;
TextData	*tdata;
{
	Widget	pd, menu;
	char	**p;
	XmString	str;
	Arg	args[8];
	int	i, n;
	char	buf[32];
	strcpy(buf,name); strcat(buf,"Menu");
	pd = XmCreatePulldownMenu(parent,buf,ShellArgs,NShellArg);
	XtAddCallback(pd,XmNentryCallback,FontCB,(XtPointer)tdata);
	for (i = 0, p = names; *p; i ++, p++) {
		XtSetArg(args[0],XmNuserData,(XtPointer)i);
		XtManageChild(XmCreatePushButton(pd,*p,args,1));
	}
	strcpy(buf,name); buf[0] -= 'a' - 'A';
	str = XmStringCreateSimple(buf);
	n = 0;
	XtSetArg(args[n],XmNorientation,XmVERTICAL); n++;
	XtSetArg(args[n],XmNsubMenuId,pd); n++;
	XtSetArg(args[n],XmNlabelString,str); n++;
	XtSetArg(args[n],XmNtopAttachment,XmATTACH_FORM); n++;
	if (left) {
		XtSetArg(args[n],XmNleftAttachment,XmATTACH_WIDGET); n++;
		XtSetArg(args[n],XmNleftWidget,left); n++;
	} else {
		XtSetArg(args[n],XmNleftAttachment,XmATTACH_FORM); n++;
	}
	XtManageChild(menu=XmCreateOptionMenu(parent,name,args,n));
	XmStringFree(str);
	return menu;
}
static Widget make_alignment_menu(parent,left,top)
Widget	parent, left, top;
{
	static	char	*values[] = { "left", "center", "right", NULL };
	XmString	str = XmStringCreateSimple("Alignment");
	Widget	menu, pd;
	char	**p;
	int	i, n = 0;
	Arg	args[8];
	pd = XmCreatePulldownMenu(parent,"alignmentMenu",ShellArgs,NShellArg);
	for (i = 0, p = values; *p; i++, p++) {
		XtSetArg(args[0],XmNuserData,(XtPointer)i);
		XtManageChild(XmCreatePushButton(pd,*p,args,1));
	}
	XtSetArg(args[n],XmNlabelString,str); n++;
	XtSetArg(args[n],XmNsubMenuId,pd); n++;
	XtSetArg(args[n],XmNleftAttachment,XmATTACH_WIDGET); n++;
	XtSetArg(args[n],XmNleftWidget,left); n++;
	XtSetArg(args[n],XmNtopAttachment,XmATTACH_WIDGET); n++;
	XtSetArg(args[n],XmNtopWidget,top); n ++;
	XtSetArg(args[n],XmNrightAttachment,XmATTACH_FORM); n++;
	XtSetArg(args[n],XmNbottomAttachment,XmATTACH_FORM); n++;
	XtManageChild(menu=XmCreateOptionMenu(parent,"alignment",args,n));
	XmStringFree(str);
	return menu;
}
static void helpCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	static Widget	dialog = NULL;
	String	*info = (String *)cl;
	if (!dialog) createHelpDialog(w,info[0],info[1],&dialog);
	XtManageChild(dialog);
}
Widget	CreateTextInputDialog(parent,info,text)
Widget	parent;		/* parent widget */
String	*info;		/* name of dialog widget, help message, and text */
Widget	*text;		/* text widget return */
{
	Widget	dialog, form, box, label;
	int	n, m, k, j;
	Arg	args[8];
	TextData	*tdata;
	dialog = XmCreateQuestionDialog(parent,info[0],ShellArgs,NShellArg);
	XtUnmanageChild(XmMessageBoxGetChild(dialog,XmDIALOG_CANCEL_BUTTON));
	tdata = (TextData *)malloc(sizeof(TextData));
	memset(tdata,0,sizeof(TextData));
	XtManageChild(form=XmCreateForm(dialog,"form",NULL,0));
	tdata->font_menu = make_option_menu(font_names,"font",form,NULL,tdata);
	tdata->style_menu
	 = make_option_menu(style_names,"style",form,tdata->font_menu,tdata);
	tdata->size_menu
	 = make_option_menu(size_names,"size",form,tdata->style_menu,tdata);
	n = 0;
	XtSetArg(args[n],XmNeditMode,XmMULTI_LINE_EDIT); n++;
	XtSetArg(args[n],XmNtopAttachment,XmATTACH_WIDGET); n++;
	XtSetArg(args[n],XmNtopWidget,tdata->font_menu); n++;
	XtSetArg(args[n],XmNleftAttachment,XmATTACH_FORM); n++;
	XtSetArg(args[n],XmNrightAttachment,XmATTACH_FORM); n++;
	XtSetArg(args[n],XmNuserData,(XtPointer)tdata); n++;
	XtManageChild(*text=XmCreateScrolledText(form,"text",args,n));
	XtAddCallback(*text,XmNvalueChangedCallback,TextCB,(XtPointer)tdata);
	n = 0;
	XtSetArg(args[n],XmNtopAttachment,XmATTACH_WIDGET); n++;
	XtSetArg(args[n],XmNtopWidget,*text); n++;
	XtSetArg(args[n],XmNbottomAttachment,XmATTACH_WIDGET); n++;
	XtSetArg(args[n],XmNleftAttachment,XmATTACH_FORM); n++;
	XtManageChild(label=XmCreateLabel(form,"X=",args,n));
	n = 3;
	XtSetArg(args[n],XmNleftAttachment,XmATTACH_WIDGET); n++; m = n;
	XtSetArg(args[n],XmNleftWidget,label); n++; k = n;
	XtSetArg(args[n],XmNcolumns,4); n++; j = n;
	XtSetArg(args[n],XmNvalue,"0"); n++;
	XtManageChild(tdata->x_text=XmCreateText(form,"xtext",args,n));
	XtSetArg(args[m],XmNleftWidget,tdata->x_text);
	XtManageChild(label=XmCreateLabel(form,"  Y=",args,k));
	XtSetArg(args[m],XmNleftWidget,label);
	XtSetArg(args[j],XmNvalue,"20");
	XtManageChild(tdata->y_text=XmCreateText(form,"ytext",args,n));
	tdata->alignment_menu = make_alignment_menu(form,tdata->y_text,*text);
	XtAddCallback(dialog,XmNhelpCallback,helpCB,info+1);
	return dialog;
}
