#define	NActiveStates	8
#define GeneLen		NActiveStates

typedef	struct {
	unsigned char	state;	/* daughter's state and next state */
	unsigned char	alpha, beta, gamma;	/* relative orientation */
}	Gene;

typedef	struct {
	double	x, y, z;
}	ThreeDPosition;

typedef struct cell_rec {
	struct cell_rec *next, *mother;
	unsigned int	step, state;
	double	glu, h2o, newglu, newh2o;
	double	x, y, z, rr;	/* rr is not real radius, only for display */
	double	afm[4][4];
	double	draw_x, draw_y, draw_z, draw_r, C; /* working memory for drawing */
}	Cell;

typedef	struct {
	int	score, id, size;
	Cell	*cells;
	Gene	gene[GeneLen];
}	Individual;

typedef enum { SelGlobal3rd, SelLocal3rd, SelLocalSel } SelectionMode;
typedef enum { CrsOnePoint, CrsTwoPoints, CrsUniform } CrossoverMode;
